Skip to content
Start here

Create integration

zero_trust.casb.integrations.create(IntegrationCreateParams**kwargs) -> IntegrationCreateResponse
POST/accounts/{account_id}/one/integrations

Creates a new integration for the specified application. Integration creation with OAuth is not supported by API at the moment. For other auth methods, use GET /v2/applications/{application_id}/credential-guide to see the required credential structure and example payloads for each vendor.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
ParametersExpand Collapse
account_id: str
application: Literal["ANTHROPIC", "AWS", "BITBUCKET", 12 more]

Vendor/application slug (e.g., GOOGLE_WORKSPACE).

  • ANTHROPIC - ANTHROPIC
  • AWS - AWS
  • BITBUCKET - BITBUCKET
  • BOX - BOX
  • CONFLUENCE - CONFLUENCE
  • DROPBOX - DROPBOX
  • GITHUB - GITHUB
  • GOOGLE_CLOUD_PLATFORM - GOOGLE_CLOUD_PLATFORM
  • GOOGLE_WORKSPACE - GOOGLE_WORKSPACE
  • JIRA - JIRA
  • MICROSOFT_INTERNAL - MICROSOFT_INTERNAL
  • OPENAI - OPENAI
  • SALESFORCE - SALESFORCE
  • SERVICENOW - SERVICENOW
  • SLACK - SLACK
One of the following:
"ANTHROPIC"
"AWS"
"BITBUCKET"
"BOX"
"CONFLUENCE"
"DROPBOX"
"GITHUB"
"GOOGLE_CLOUD_PLATFORM"
"GOOGLE_WORKSPACE"
"JIRA"
"MICROSOFT_INTERNAL"
"OPENAI"
"SALESFORCE"
"SERVICENOW"
"SLACK"
credentials: Dict[str, object]

Credentials for the integration.

name: str

Name of the integration.

maxLength256
minLength1
auth_method: Optional[str]

Authentication method slug (uses default if omitted).

minLength1
dlp_profiles: Optional[Sequence[str]]

List of DLP profile IDs to associate.

permissions: Optional[Sequence[str]]

List of permission scopes (uses policy defaults if empty).

use_cases: Optional[List[Literal["casb", "ces", "auto_remediation"]]]

List of use case or feature slugs to enroll (e.g., [‘casb’, ‘ces’, ‘auto_remediation’]).

One of the following:
"casb"
"ces"
"auto_remediation"
ReturnsExpand Collapse
class IntegrationCreateResponse:

The requested item.

id: str

Integration ID.

formatuuid
application: Dict[str, Optional[str]]
auth_method: Optional[Dict[str, str]]

The integration’s authentication method.

created: datetime

When the integration was created.

formatdate-time
credentials_expiry: datetime

Credentials expiry time.

formatdate-time
dlp_profiles: List[str]

DLP Profiles enabled for the integration.

health_details: List[Dict[str, object]]

Health details with remediation hints.

is_paused: bool

Whether the user paused the integration.

last_hydrated: datetime

Last time the integration was hydrated.

formatdate-time
name: str

Name of the integration.

status: str

Integration status.

updated: datetime

When the integration was last updated.

formatdate-time
use_cases: List[Dict[str, object]]

Use cases enabled for the integration.

Create integration

import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
integration = client.zero_trust.casb.integrations.create(
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
    application="GOOGLE_WORKSPACE",
    credentials={
        "admin_email": "admin@corp.com"
    },
    name="My Google Workspace",
    auth_method="service_account",
    dlp_profiles=["e91a2360-da51-4fdf-9711-bcdecd462614"],
    permissions=["https://www.googleapis.com/auth/drive.readonly"],
    use_cases=["casb", "ces"],
)
print(integration.id)
{
  "errors": [],
  "messages": [],
  "result": {
    "application": {
      "category": "Productivity",
      "display_name": "Google Workspace",
      "logo": "https://dash.cloudflare.com/v2/static/google_workspace.png"
    },
    "auth_method": {
      "display_name": "OAuth 2.0",
      "id": "oauth"
    },
    "authorization_link": {
      "components": {
        "client_id": "abc",
        "instance_name": "example"
      },
      "link": "https://example.cloudflare.com/authorize"
    },
    "created": "2025-01-01T00:00:00Z",
    "credentials_expiry": "2026-01-01T00:00:00Z",
    "dlp_profiles": [
      "e91a2360-da51-4fdf-9711-bcdecd462614"
    ],
    "health_details": [],
    "id": "019d2e6a-d995-7185-afbd-4feead9e42ec",
    "is_paused": false,
    "last_hydrated": "2025-04-10T08:30:00Z",
    "name": "My Google Workspace",
    "status": "Healthy",
    "updated": "2025-04-10T08:30:00Z",
    "use_cases": [
      {
        "description": "Discover and secure SaaS applications",
        "features": [
          {
            "description": "Automatically remediate security issues (requires write permissions)",
            "id": "auto_remediation",
            "is_enabled": true,
            "name": "Auto Remediation",
            "permissions": [
              {
                "display_name": "Manage users",
                "scope": "https://www.googleapis.com/auth/admin.directory.user",
                "status": "granted"
              }
            ]
          }
        ],
        "id": "casb",
        "is_enabled": true,
        "name": "Cloud Access Security Broker",
        "permissions": [
          {
            "display_name": "Drive (Read Only)",
            "scope": "https://www.googleapis.com/auth/drive.readonly",
            "status": "granted"
          },
          {
            "display_name": "Gmail (Read Only)",
            "scope": "https://www.googleapis.com/auth/gmail.readonly",
            "status": "missing"
          }
        ]
      },
      {
        "description": "Protect against email-based threats",
        "features": [],
        "id": "ces",
        "is_enabled": false,
        "name": "Cloud Email Security",
        "permissions": []
      }
    ]
  },
  "success": true
}
Returns Examples
{
  "errors": [],
  "messages": [],
  "result": {
    "application": {
      "category": "Productivity",
      "display_name": "Google Workspace",
      "logo": "https://dash.cloudflare.com/v2/static/google_workspace.png"
    },
    "auth_method": {
      "display_name": "OAuth 2.0",
      "id": "oauth"
    },
    "authorization_link": {
      "components": {
        "client_id": "abc",
        "instance_name": "example"
      },
      "link": "https://example.cloudflare.com/authorize"
    },
    "created": "2025-01-01T00:00:00Z",
    "credentials_expiry": "2026-01-01T00:00:00Z",
    "dlp_profiles": [
      "e91a2360-da51-4fdf-9711-bcdecd462614"
    ],
    "health_details": [],
    "id": "019d2e6a-d995-7185-afbd-4feead9e42ec",
    "is_paused": false,
    "last_hydrated": "2025-04-10T08:30:00Z",
    "name": "My Google Workspace",
    "status": "Healthy",
    "updated": "2025-04-10T08:30:00Z",
    "use_cases": [
      {
        "description": "Discover and secure SaaS applications",
        "features": [
          {
            "description": "Automatically remediate security issues (requires write permissions)",
            "id": "auto_remediation",
            "is_enabled": true,
            "name": "Auto Remediation",
            "permissions": [
              {
                "display_name": "Manage users",
                "scope": "https://www.googleapis.com/auth/admin.directory.user",
                "status": "granted"
              }
            ]
          }
        ],
        "id": "casb",
        "is_enabled": true,
        "name": "Cloud Access Security Broker",
        "permissions": [
          {
            "display_name": "Drive (Read Only)",
            "scope": "https://www.googleapis.com/auth/drive.readonly",
            "status": "granted"
          },
          {
            "display_name": "Gmail (Read Only)",
            "scope": "https://www.googleapis.com/auth/gmail.readonly",
            "status": "missing"
          }
        ]
      },
      {
        "description": "Protect against email-based threats",
        "features": [],
        "id": "ces",
        "is_enabled": false,
        "name": "Cloud Email Security",
        "permissions": []
      }
    ]
  },
  "success": true
}